/***********************************************************
	- if enter key is pushed, display ppm pulse duration
		instead if rotation percentage
*************************************************************/
void Simpletest (bit ms)
{
	static char ctr;

	uns24 calc24,cl;
	char i;
	uns16 calc,calc2,MaxAmp;
	uns32 SumVolt;
	uns16 CountVolt;
	
	OpsReady = 0;
	StartStp = 0;
	cleardisplay ();
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	ServoSeq = 0;
	FillBuffer(7,16);
	DisplayLine (0,16);
	TimingMode = 0;
	TMR1H = 0;
	TMR1L = 0;
	TMR1IF = 0;
	TMR1IE = 1;		//int will clear TmrEndFg
	TMR1ON = 1;
	Tmr1EndFg = 0;
	TMR2ON = 1;
	TMR2IE = 1;
	PWMDuty = 0;

	while (SW3 == 1)
	{
//control voltage with pwm		
		ScanAnalog();
//		if (NextANP == 1) 
//		{
			//CtlVolt (Volt,0);
//		}
		if (LocANP == 7)
		{
			if (MaxAmp < ANP3) MaxAmp = ANP3;
			SumVolt += ANP1;
			CountVolt ++;
		}	
	
// other routines
	if (msflg)
		{
			ctr++;
			LcdTmr ++;
			if (LcdTmr == 300)
			{
				LcdTmr = 0;
				if (SW2 == 1)
				{
					calc24 = ModANP0 * 200;
					calc = (uns16)calc24 / 511;
					cvhexbcdN(calc);
					if (Dir) writepos ('+',0,1);
					else writepos ('-',0,1);
					outdata (cent);
					outdata (dix);
					outdata (un);
					outdata ('%');
					outdata (' ');
				}
				else 
				{
					calc = ANcalc/3;
					cvhexbcdN(calc);
					writepos (mil,0,1);
					outdata (cent);
					outdata (dix);
					outdata (un);
					outdata ('u');
					outdata (' ');	
				}	
				calc24 =  (uns24)MaxAmp * 1000;
				MaxAmp = 0;
				cl = calc24 / CoefAmp;
				calc = cl;
				cvhexbcdN(calc);
				writepos (mil,6,1);
				outdata (cent);
				outdata (',');
				outdata (dix);
				outdata (un);
				outdata (' ');
				calc24 =  (uns24)SumVolt / CountVolt;
				SumVolt = 0;
				CountVolt = 0;
				calc24 *= 1000;
				cl = calc24 / CoefVolt;
				calc = cl;
				cvhexbcdN(calc);
				writepos (cent,12,1);
				outdata (',');
				outdata (dix);
				outdata (un);
			}	
			if (ctr == 200)
			{
				ctr = 0;
				Led = !Led;
			}
			msflg = 0;	
		}
	}
	TMR1ON = 0;
	TMR1IE = 0;
	TMR2IE = 0;
	TMR2IF = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	Led = 0;	
	MenuInit();
	MenuMode = 1;
}

void StartStop (void)
{
	static char ctr;

	uns24 calc24,cl;
	char i;
	uns16 calc,calc2,MaxAmp;
	uns32 SumVolt;
	uns16 CountVolt;
	char svvolt;
	
	svvolt = VREFCON2;
	VREFCON2 = 0x14;;
	Volt = 610;
	OpsReady = 0;
	StartStp = 1;
	cleardisplay ();
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	ServoSeq = 0;
	FillBuffer(7,16);
	DisplayLine (0,16);
	TimingMode = 0;
	TMR1H = 0;
	TMR1L = 0;
	TMR1IF = 0;
	TMR1IE = 1;		//int will clear TmrEndFg
	TMR1ON = 1;
	Tmr1EndFg = 0;
	TMR2ON = 1;
	TMR2IE = 1;
	PWMDuty = 0;
	
	while (SW3 == 1)
	{
//control voltage with pwm		
		ScanAnalog();
		if (LocANP == 7)
		{
			if (MaxAmp < ANP3) MaxAmp = ANP3;
			SumVolt += ANP1;
			CountVolt ++;
		}	
	
// other routines
	if (msflg)
		{
			ctr++;
			LcdTmr ++;
			if (LcdTmr == 500)
			{
				LcdTmr = 0;
				if (SW2 == 1)
				{
					if (SW1 == 0) Dir = 0;
					else Dir = 1;
					calc = 100;
					cvhexbcdN(calc);
					if (Dir) writepos ('+',0,1);
					else writepos ('-',0,1);
					outdata (cent);
					outdata (dix);
					outdata (un);
					outdata ('%');
					outdata (' ');
				}
				else 
				{
					calc = ANcalc/3;
					cvhexbcdN(calc);
					writepos (mil,0,1);
					outdata (cent);
					outdata (dix);
					outdata (un);
					outdata ('u');
					outdata (' ');	
				}	
				calc24 =  (uns24)MaxAmp * 1000;
				MaxAmp = 0;
				cl = calc24 / CoefAmp;
				calc = cl;
				cvhexbcdN(calc);
				writepos (mil,6,1);
				outdata (cent);
				outdata (',');
				outdata (dix);
				outdata (un);
				outdata (' ');
				calc24 =  (uns24)SumVolt / CountVolt;
				SumVolt = 0;
				CountVolt = 0;
				calc24 *= 1000;
				cl = calc24 / CoefVolt;
				calc = cl;
				cvhexbcdN(calc);
				writepos (cent,12,1);
				outdata (',');
				outdata (dix);
				outdata (un);
			}	
			if (ctr == 200)
			{
				ctr = 0;
				Led = !Led;
			}
			msflg = 0;	
		}
	}
	TMR1ON = 0;
	TMR1IE = 0;
	TMR2IE = 0;
	TMR2IF = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	VREFCON2 = svvolt;
	Led = 0;	
	MenuInit();
	MenuMode = 1;
	StartStp = 0;	
}