/// ops for param change

void SetVolt (bit ms)
{
	char ctr2;
	uns24 calc24,cl;
	uns16 MaxAmp;
	char i,oldrot;
	uns16 calc,calc2;
	uns16 MaxVolt;
	uns16 MinVolt;
	
	upcntr = 3;
	oldrot = 0;
	Volt = 551;
	MaxVolt = 0;
	MinVolt = 1023;
	OpsReady = 0;
	ServoSeq = 0;
	cleardisplay();
	FillBuffer(11,16);
	DisplayLine (0,16);	
	TMR1H = 0;
	TMR1L = 0;
	TMR1IF = 0;
	Tmr1EndFg = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	TMR1IE = 1;		//int will clear TmrEndFg
	TMR1ON = 1;
	TMR2ON = 1;
	TMR2IE = 1;
	PWMDuty = 0;
	while (SW3 == 1)		// sw3 returns to menu
	{
		if (upcntr > 7) upcntr = 7;
		if (oldrot != upcntr)
		{
			oldrot = upcntr;
			switch (upcntr)
			{
				case 0:
				{
					VREFCON2 = 0x0C;		//3.5v
					break;	
				}	
				case 1:
				{
					VREFCON2 = 0x0E;	// 4v
					break;
				}	
				case 2:
				{
					VREFCON2 = 0x10;		//4.5v
					break;	
				}	
				case 3:
				{
					VREFCON2 = 0x11;		// 5v
					break;
				}	
				case 4:
				{
					VREFCON2 = 0x13;		//5.5v
					break;	
				}	
				case 5:
				{
					VREFCON2 = 0x15;		// 6v
					break;
				}
				case 6:
				{
					VREFCON2 = 0x16;		//6.5v
					break;	
				}	
				case 7:
				{
					VREFCON2 = 0x18;		// 7v
					break;
				}		
			}	
		}	
		ScanAnalog();
		if (NextANP == 1) 
		{
//			CtlVolt (Volt,0);
			CPANP0 = ANP0/2;
			CPANP0 += 256;
			if (CorDir) CPANP0 += Corr;
			else CPANP0 -= Corr;
		}
		if (LocANP == 7)
		{
			if (MaxVolt < ANP1) MaxVolt = ANP1;
			if (MinVolt > ANP1) MinVolt = ANP1;
		}	
// other routines
		if (msflg)
		{
			ctr2++;
			LcdTmr ++;
			if (LcdTmr == 300)
			{
				LcdTmr = 0;
				calc = ModANP0 * 200;
				calc = calc / 511;
				cvhexbcdN(calc);
				if (Dir) writepos ('+',0,1);
				else writepos ('-',0,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata ('%');
				outdata (' ');
				calc24 =  (uns24)MaxVolt * 1000;
				MaxAmp = 0;
				cl = calc24 / CoefVolt;
				calc = cl;
				cvhexbcdN(calc);
				writepos (cent,6,1);
				outdata (',');
				outdata (dix);
				outdata (un);
				outdata (' ');
				calc24 =  (uns24)MinVolt * 1000;
				cl = calc24 / CoefVolt;
				calc = cl;
				cvhexbcdN(calc);
				writepos (cent,12,1);
				outdata (',');
				outdata (dix);
				outdata (un);
				MaxVolt = 0;
				MinVolt = 1023;
			}	
			if (ctr2 == 200)
			{
				ctr2 = 0;
				Led = !Led;
			}
			msflg = 0;	
		}
	}	
	TMR1ON = 0;
	TMR1IE = 0;
	TMR2IE = 0;
	TMR2IF = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	Led = 0;	
	MenuInit();
	MenuMode = 1;
	
}		

void SetDecal (bit ms)
{
	char ctr2;
	uns24 calc24,cl;
	uns16 MaxAmp;
	char i,oldrot;
	uns16 calc,calc2,tpc;
	bit dir;
	uns32 SumVolt;
	uns16 CountVolt;
	
	
	upcntr = 50;
	oldrot = upcntr;
	Corr = 0;
	dir = 0;
	oldrot = 4;
	MaxAmp = 0;
	OpsReady = 0;
	ServoSeq = 0;
	cleardisplay();
	FillBuffer(9,16);
	DisplayLine (0,16);	
	TMR1H = 0;
	TMR1L = 0;
	TMR1IF = 0;
	Tmr1EndFg = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	TMR1IE = 1;		//int will clear TmrEndFg
	TMR1ON = 1;
	TMR2ON = 1;
	TMR2IE = 1;
	PWMDuty = 0;
	while (SW3 == 1)		// sw3 returns to menu
	{
		if (upcntr > 100) upcntr = 100;
		if (oldrot != upcntr)
		{
			oldrot = upcntr;
			if (upcntr > 50)
			{
				tpc = upcntr - 50;
				CorDir = 1;
			}		
			else
			{
				tpc = 50 - upcntr;
				CorDir = 0;
			}
		}	
		ScanAnalog();
		if (NextANP == 1) 
		{
			Corr = tpc * 32;
			if (CorDir) Pos0 = 4500 + Corr;
			else Pos0 = 4500 - Corr;
		}
		if (LocANP == 7)
		{
			if (MaxAmp < ANP3) MaxAmp = ANP3;
			SumVolt += ANP1;
			CountVolt ++;

		}	
// other routines
		if (msflg)
		{
			ctr2++;
			LcdTmr ++;
			if (LcdTmr == 500)
			{
				LcdTmr = 0;
				calc24 = (uns24)ModANP0 * 200;
				cl = calc24 / 511;
				calc = cl;
				cvhexbcdN(calc);
				if (Dir) writepos ('+',0,1);
				else writepos ('-',0,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata ('%');
				outdata (' ');
				calc24 =  (uns24)MaxAmp * 1000;
				MaxAmp = 0;
				cl = calc24 / CoefAmp;
				calc = cl;
				cvhexbcdN(calc);
				writepos (mil,6,1);
				outdata (cent);
				outdata (',');
				outdata (dix);
				outdata (un);
				outdata (' ');
				if (upcntr == 50)
				{
					writepos (' ',12,1);
					dix = 0x30;
					un = 0x30;
				}	
				else
				{ 
					if (!CorDir)
					
					{
						writepos ('-',12,1);
						cvhexbcdN(50-upcntr);
					}	
					else
					{
						writepos ('+',12,1);
						cvhexbcdN(upcntr-50);
					}
				}	
				outdata (dix);
				outdata (un);
				outdata (' ');
				outdata (' ');
			}	
			if (ctr2 == 200)
			{
				ctr2 = 0;
				Led = !Led;
			}
			msflg = 0;	
		}
	}	
	TMR1ON = 0;
	TMR1IE = 0;
	TMR2IE = 0;
	TMR2IF = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	Led = 0;	
	MenuInit();
	MenuMode = 1;
	
}

void SetLimites (bit ms)
{
	char ctr2;
	uns24 calc24,cl;
	uns16 MaxAmp;
	char i,oldrot;
	uns16 calc,calc2,tpc;
	bit dir;
	uns32 SumVolt;
	uns16 CountVolt;
	
	upcntr = 50;
	oldrot = upcntr;
	Corr = 0;
	dir = 0;
	oldrot = 4;
	MaxAmp = 0;
	OpsReady = 0;
	ServoSeq = 0;
	cleardisplay();
	FillBuffer(12,16);
	DisplayLine (0,16);	
	TMR1H = 0;
	TMR1L = 0;
	TMR1IF = 0;
	Tmr1EndFg = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	TMR1IE = 1;		//int will clear TmrEndFg
	TMR1ON = 1;
	TMR2ON = 1;
	TMR2IE = 1;
	PWMDuty = 0;
	while (SW3 == 1)		// sw3 returns to menu
	{
		if (upcntr > 100) upcntr = 100;
		if (oldrot != upcntr)
		{
			oldrot = upcntr;
			if (upcntr > 50)
			{
				tpc = upcntr - 50;
				CorDir = 1;
			}		
			else
			{
				tpc = 50 - upcntr;
				CorDir = 0;
			}
			tpc *= 8;
			if (CorDir == 0)
			{
				if (ANP0 > 510) LimiteH = 511 - tpc;
				else LimiteL = 512 - tpc;
			}	
			else 
			{
				if (ANP0 > 510) LimiteH = 511 + tpc;
				else LimiteL = 512 + tpc;
			}	
		}
		ScanAnalog();
		if (LocANP == 7)
		{
			if (MaxAmp < ANP3) MaxAmp = ANP3;
			SumVolt += ANP1;
			CountVolt ++;

		}	
// other routines
		if (msflg)
		{
			ctr2++;
			LcdTmr ++;
			if (LcdTmr == 500)
			{
				LcdTmr = 0;
				calc24 = (uns24)ModANP0 * 200;
				cl = calc24 / 511;
				calc = cl;
				cvhexbcdN(calc);
				if (Dir) writepos ('+',0,1);
				else writepos ('-',0,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata ('%');
				outdata (' ');
				calc24 =  (uns24)MaxAmp * 1000;
				MaxAmp = 0;
				cl = calc24 / CoefAmp;
				calc = cl;
				cvhexbcdN(calc);
				writepos (mil,6,1);
				outdata (cent);
				outdata (',');
				outdata (dix);
				outdata (un);
				outdata (' ');
				if (upcntr == 50)
				{
					writepos (' ',12,1);
					dix = 0x30;
					un = 0x30;
				}	
				else
				{ 
					if (!CorDir)
					
					{
						writepos ('-',12,1);
						cvhexbcdN(50-upcntr);
					}	
					else
					{
						writepos ('+',12,1);
						cvhexbcdN(upcntr-50);
					}
				}	
				outdata (dix);
				outdata (un);
				outdata (' ');
				outdata (' ');
			}	
			if (ctr2 == 200)
			{
				ctr2 = 0;
				Led = !Led;
			}
			msflg = 0;	
		}
	}	
	TMR1ON = 0;
	TMR1IE = 0;
	TMR2IE = 0;
	TMR2IF = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	Led = 0;	
	MenuInit();
	MenuMode = 1;
}

void ReInit (bit ms)
{
	VREFCON2 = 0x11;
	Pos0 = 4500;
	LimiteH = 511;
	LimiteL = 512;
	cleardisplay();
	FillBuffer(26,16);
	DisplayLine (0,7);
	FillBuffer(25,16);
	DisplayLine (1,16);
	while (SW3);
	Led = 0;	
	MenuInit();
	MenuMode = 1;
}				