/************************************************
		MENUS
****************************************************/
#include "Texte.h"

/***************************************************
		FillBuffer
Fil a buffer with full line of spaces, then msg
MsgNbr is Idx entry
NbrChar if of course number of text characters
**************************************************/

void FillBuffer (char MsgNbr,char NbrChar)
{
	char i,dat,nbc;
	uns16 iptr,calc16;
	size2 const char *ptr = Text[0].txtptr;
	
	if (NbrChar!= 0)
	{
		for (i=0;i!=NbrChar;i++)
		{
			OutBuf[i] =' ';
		}
	}
	// calculate length of message
	iptr = Idx[MsgNbr];
	calc16 = Idx[MsgNbr+1];
	nbc = calc16-iptr;
	// adjust pointer
	ptr = ptr+iptr;
	// move data
	for (i=0;i!=nbc;i++)
	{
		dat = *ptr;
		OutBuf[i] = dat;
		ptr++;
	}


}
void DisplayLine(char Line, char nbrChar)
{
	char i;
	writepos (OutBuf[0],0,Line);
	for (i=1;i!=nbrChar;i++)
	{
		outdata(OutBuf[i]);
	}
}		

void MenuInit (void)
{
	FillBuffer(0,16);
	DisplayLine(0,16);
	FillBuffer(1,16);
	DisplayLine (1,16);
	upcntr = 0;
	OldMenu = 1;
	MenuLevel = 0;
	SubMenu1 = 6;
	SubMenu2 = 0;
	RselSWchg = 0;
	oldselSW = SELSW;
	OpsReady = 0;
	Led = 0;	
}
	
void Menu(bit ms)
{
	char msgptr,nbc;
	bit DispFg;
	
	DispFg = 0;
	if (MenuLevel == 0)	
	{
		if (upcntr > 5) upcntr = 5;
		if (upcntr != OldMenu)
		{
			OldMenu = upcntr;
			msgptr = upcntr + 1;
			SubMenu1 = msgptr;
			DispFg = 1;
			switch (msgptr)
			{
				case 1:
				{
					nbc = 14;
					SelNbr = 1;
					break;
				}
				case 2:
				{
					nbc = 14;
					SelNbr = 4;
					break;
				}
				case 3:
				{
					nbc = 13;
					SelNbr = 3;
					break;
				}	
				case 4:
				{
					nbc = 14;
					SelNbr = 3;
					break;
				}
				case 5:
				{
					nbc = 12;
					SelNbr = 1;
					break;
				}
				case 6:
				{
					nbc = 15;
					SelNbr = 2;
					break;
				}	
			}		
		}
		
	}
	if (MenuLevel == 1)
	{
		switch (SubMenu1)
		{
			case 1:		//essai simple
			{
				OpsMode = 1;
				OpsReady = 1;
				DispFg = 0;
				// no sub options
				break;
			}
			case 2:		//Var Parameres
			{
				if (upcntr > SelNbr) upcntr = SelNbr;
				if (upcntr != OldMenu)
				{
					DispFg = 1;
					OldMenu = upcntr;
					switch (upcntr)
					{
						case 0:		//Sel tension
						{
							OpsMode = 10;
							OpsReady = 1;
							nbc = 7;
							msgptr = 16;
							break;
						}
						case 1:		//Decal 0
						{
							OpsMode = 11;
							OpsReady = 1;
							nbc = 10;
							msgptr = 17; 
							break;
						}
						case 2:		// limites rot
						{
							OpsMode  = 12;
							OpsReady = 1;
							nbc = 16;
							msgptr = 18;
							break;	
						}
						case 3:		// Init Defauts
						{
							OpsMode  = 13;
							OpsReady = 1;
							nbc = 15;
							msgptr = 19;
							break;	
						}
						case 4:		// Retour
						{
							OpsMode  = 0;
							OpsReady = 0;
							nbc = 14;
							msgptr = 22;
							break;	
						}
					}		
				}
				break;
			}				
			case 3:		//Temps Reponse
			{
				if (upcntr > SelNbr) upcntr = SelNbr;
				if (upcntr != OldMenu)
				{
					DispFg = 1;
					OldMenu = upcntr;
					FillBuffer(13,16);
					DisplayLine (0,16);
					switch (upcntr)
					{
						case 0:		//Sel Position 0
						{
							OpsMode = 20;
							OpsReady = 1;
							nbc = 16;
							msgptr = 27;
							break;
						}
						case 1:
						{
							OpsMode = 21;
							OpsReady = 1;
							nbc = 16;
							msgptr = 28;
							break;
						}
						case 2:
						{
							OpsMode = 22;
							OpsReady = 1;
							nbc = 4;
							msgptr = 29;
							break;
						}		
						case 3:		// Retour
						{
							OpsMode  = 0;
							OpsReady = 0;
							nbc = 14;
							msgptr = 22;
							break;	
						}
					}	
				}
				break;
			}
			case 4:		//Simu Recepteur
			{
				OpsMode = 30;
				OpsReady = 1;
				DispFg = 0;
				break;
			}	
			case 5:		//Start/Stop mode
			{
				OpsMode = 40;
				OpsReady = 1;
				DispFg = 0;
				break;
			}
			case 6:		//Calibrage
			{
				if (upcntr > SelNbr) upcntr = SelNbr;
				if (upcntr != OldMenu)
				{
					DispFg = 1;
					OldMenu = upcntr;
					
					msgptr = upcntr + 20;
					switch (upcntr)
					{
						case 0:		//cal tension
						{
							OpsMode = 60;
							OpsReady = 1;
							nbc = 11;
							break;
						}
						case 1:		//cal courant
						{
							OpsMode = 61;
							OpsReady = 1;
							nbc = 11;
							break;
						}
						case 2:
						{
							OpsReady = 0;
							nbc = 14;
							msgptr = 22;
							break;	
						}
					}		
		
				}
				break;
			}						
		}
	}
	if (DispFg)
	{
		FillBuffer(msgptr,16);
		DisplayLine (1,16);
	}
// Pocess select switch		
	if (SELSW == 0)
	{
		Led = 0;
		tempo (20,1);
		while (SELSW == 0);
		tempo (20,1);
		Led = 1;
		RselSWchg = 0;
		if (MenuLevel == 0)
		{
			if (SubMenu1 == 1)	// direct start no sub menu
			{
				MenuMode = 0;
				OpsMode = 1;
			}
			if (SubMenu1 == 5)
			{
				MenuMode = 0;
				OpsMode = 40;
			}		
			MenuLevel = 1;
			OpsReady = 0;
			upcntr = 0;
		}
		else if (MenuLevel == 1)
		{
			switch (SubMenu1)
			{
				case 1:		//essai simple
				{
					DispFg = 0;
					break;
				}
				case 2:		//Var Parameres
				{
					if (upcntr == 0)
					{
						if (OpsReady) MenuMode = 0;
					}
					if (upcntr == 1) 
					{
						if (OpsReady) MenuMode = 0;
					}
					if (upcntr == 2)
					{
						if (OpsReady) MenuMode = 0;
					}
					if (upcntr == 3) 
					{
						if (OpsReady) MenuMode = 0;
					}		
					if (upcntr == 4) MenuInit();
					break;
				}
				case 3:		//Temps Reponse
				{
					if (upcntr == 0)
					{
						if (OpsReady) MenuMode = 0;
					}
					if (upcntr == 1) 
					{
						if (OpsReady) MenuMode = 0;
					}
					if (upcntr == 2)
					{
						if (OpsReady) MenuMode = 0;
					}
					if (upcntr == 3) MenuInit();
					break;
				}
				case 4:		//Simu Recepteur
				{
					MenuMode = 0;
					Led = 0;
					break;
				}	

				case 6:		//Calibrage
				{
					if (upcntr == 0)
					{
						if (OpsReady) MenuMode = 0;
					}
					if (upcntr == 1) 
					{
						if (OpsReady) MenuMode = 0;
					}	
					if (upcntr == 2) MenuInit();
				}		
				break;
			}	
		}			
	}			
	
}				
