//#utils

#include "Utils.h"

void tempo (uns16 durationms,bit locked)		// max 65 sec but no validity check on param
{
	tempoms = durationms + 1; 
	timer1 = 1;
	if (locked)
	while (timer1);
} 

/******************************************************
		ROTARY SWITCH UTILITY CODE

- InitRotary must be called a main init procedure to 
  define the postion at power as 0. This routine may be called
  each time a start position is needed. 
- HandelRotary is to be called in a periodic mode by the main 
  loop. All variables are global to allow also a call from
  inside interrupt routine.
  upcntr and dwncntr are increased respectfully for each turn
  click clockwise and counter clockwise. 
- Remarck : upcntr and dwncntr can be char or uns16 as needed.
	
*****************************************************/

void InitRotary (void)
{
	Roldsel = oldselB;
	Roldsel = Roldsel * 2;
	Roldsel += oldselA;
	upcntr = 0;
	dwncntr = 0;
}	
void HandelRotary (void)
{
	if (RotaryDebounce == 0)
	{ 
		if (oldselA != SELA)
		{
			Rselchg = 1;
			oldselA = SELA;
			RotaryDebounce = 5; 
		}
		if (oldselB != SELB)
		{
			Rselchg = 1;
			oldselB = SELB;
			RotaryDebounce = 5;
		}
		if (oldselSW != SELSW)
		{
			RselSWchg = 1;
			oldselSW = SELSW;
			RotaryDebounce = 10;
		}
	}
	if (Rselchg != 0)
	{
		Rselchg = 0;
		newsel = oldselB;
		newsel = newsel * 2;
		newsel = newsel + oldselA ;	
				
		switch (Roldsel)
		{
			case (0b00):
			{
				if (newsel == 0b01) if (upcntr != 0) upcntr --;
				if (newsel == 0b10) if (upcntr < 50) upcntr++;
				break;
			}
			case (0b01):
			{
				//if (newsel == 0b00) upcntr++;
				//if (newsel == 0b11) dwncntr ++;
				break;
			}	
		 	case (0b10):
		 	{
			 	//if (newsel == 0b11) upcntr++;
				//if (newsel == 0b00) dwncntr ++;
			 	break;
			}
			case (0b11):
			{
				//if (newsel == 0b10) dwncntr++;
				//if (newsel == 0b01) upcntr++;
				break;
			}
		}
		Roldsel = newsel;
	}
}